Smalltalk createPackage: 'Compiler-Strom'!
ASTNode subclass: #StromNode
	instanceVariableNames: 'tag attributes children'
	package: 'Compiler-Strom'!
!StromNode commentStamp!
I represent an assignment node.!

!StromNode methodsFor: 'accessing'!

attributes
	^ attributes
!

attributes: anObject
	attributes := anObject
!

children
	^ children
!

children: anObject
	children := anObject
!

dagChildren
	^ { self tag }
		addAll: self attributes;
		addAll: self children;
		yourself
!

tag
	^ tag
!

tag: anObject
	tag := anObject
! !

!StromNode methodsFor: 'visiting'!

acceptDagVisitor: aVisitor
	^ aVisitor visitDagNode: self
! !

